import static com.google.common.collect.FluentIterable.from;

import java.io.File;
import java.io.IOException;
import java.util.Collection;
import java.util.Comparator;
import java.util.List;
import java.util.Set;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Executor;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.ScheduledThreadPoolExecutor;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

import com.google.common.base.Function;
import com.google.common.base.Joiner;
import com.google.common.base.Predicates;
import com.google.common.base.Suppliers;
import com.google.common.base.Throwables;
import com.google.common.collect.ArrayTable;
import com.google.common.collect.FluentIterable;
import com.google.common.collect.HashBasedTable;
import com.google.common.collect.Iterables;
import com.google.common.collect.Ordering;
import com.google.common.collect.Sets;
import com.google.common.collect.Table;
import com.google.common.collect.Tables;
import com.google.common.hash.HashCode;
import com.google.common.hash.Hashing;
import com.google.common.io.Files;
import com.google.common.io.InputSupplier;
import com.google.common.util.concurrent.AsyncFunction;
import com.google.common.util.concurrent.FutureCallback;
import com.google.common.util.concurrent.Futures;
import com.google.common.util.concurrent.ListenableFuture;
import com.google.common.util.concurrent.ListenableFutureTask;
import com.google.common.util.concurrent.ListeningScheduledExecutorService;
import com.google.common.util.concurrent.MoreExecutors;

public class MainTest {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws ExecutionException 
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws IOException, InterruptedException, ExecutionException {
//
//		String string = "a,b,c,,,d,e,f";
//		String[] split = string.split(",");
//		String ret = Joiner.on(",").join(split);
//		System.out.println(ret);
//
//		Futures.addCallback(null, null);
//
//		User us = null;
//
//		
//		ListeningScheduledExecutorService executor = MoreExecutors
//				.listeningDecorator(new ScheduledThreadPoolExecutor(4));
//
//		ListenableFuture<User> task = executor.submit(new Callable<User>() {
//			@Override
//			public User call() throws Exception {
//				return new User();
//			}
//		});
//		
//		Futures.addCallback(task, new FutureCallback<Object>() {
//			@Override
//			public void onFailure(Throwable t) {
//				// log exception?
//				Throwables.propagate(t);
//			}
//
//			@Override
//			public void onSuccess(Object result) {
//				// Do something with user.
//			}
//		});
//
//		Set<User> ourFriends = us.friends;
//		FluentIterable<User> extendedNetwork = from(
//				Sets.newHashSet(Iterables.concat(from(ourFriends).transform(
//						User.FriendsAccessor.instance)))).filter(
//				Predicates.not(Predicates.in(ourFriends)));
//
//		
//		File file = null;
//		HashCode hash = Files.hash(file, Hashing.sha1());
//		byte[] digest = hash.asBytes();
//		
//		Comparator<? extends Comparable<?>> c = Ordering.natural();
		
		
		
		ListeningScheduledExecutorService executor = MoreExecutors
				.listeningDecorator(new ScheduledThreadPoolExecutor(4));

		ListenableFuture<Long> future = executor.submit(new Callable<Long>() {

			@Override
			public Long call() throws Exception {
				Thread.sleep(3000);
				System.out.printf("beep beep go go go!%n");
				return System.nanoTime();
			}
			
		});
		
		ListenableFuture<Long> chain = Futures.transform(future, new AsyncFunction<Long,Long>() {

			@Override
			public ListenableFuture<Long> apply(Long input) throws Exception {
				System.out.printf("zzZ zzZ %n");
				Thread.sleep(500);
				return Futures.immediateFuture(input);
			}
			
		});
		Thread.sleep(2000);
		System.out.printf("Boop!%n");
		//Long ret = chain.get();
		
		//System.out.printf("We found %d!%n",ret);
		
		
	}

	static class User {
		Set<User> friends;

		enum FriendsAccessor implements Function<User, Iterable<User>> {
			instance;
			@Override
			public Iterable<User> apply(User input) {
				return input.friends;
			}
		}

	}

}
