import static org.junit.Assert.*;

import java.util.Arrays;
import java.util.List;

import org.junit.Test;
import org.junit.runner.RunWith;


@RunWith(MultiAssertTestRunner.class)
public class TestWithSeveralFailuresPerAssert {

	
	@Test
	public void primeFactors() throws Exception {
		myAssertEquals(Arrays.asList(2, 5), PrimeFactors.of(10));
		myAssertEquals(Arrays.asList(2), PrimeFactors.of(2));
		myAssertEquals(Arrays.asList(2, 2, 2), PrimeFactors.of(8));
		
	}

	private static void myAssertEquals(List<Integer> expected, List<Integer> actual) {
		MultiAssertTestRunner.myAssertEquals(expected, actual);
	}


}
